    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * ShapeList.java
    029     * --------------
    030     * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: ShapeList.java,v 1.4 2005/10/18 13:24:19 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 13-Aug-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.util;
    044
    045    import java.awt.Shape;
    046    import java.io.IOException;
    047    import java.io.ObjectInputStream;
    048    import java.io.ObjectOutputStream;
    049
    050    import org.jfree.io.SerialUtilities;
    051
    052
    053    /**
    054     * A table of {@link Shape} objects.
    055     *
    056     * @author David Gilbert
    057     */
    058    public class ShapeList extends AbstractObjectList {
    059
    060        /**
    061         * Creates a new list.
    062         */
    063        public ShapeList() {
    064            super();
    065        }
    066
    067        /**
    068         * Returns a {@link Shape} object from the list.
    069         *
    070         * @param index the index (zero-based).
    071         *
    072         * @return The object.
    073         */
    074        public Shape getShape(final int index) {
    075            return (Shape) get(index);
    076        }
    077
    078        /**
    079         * Sets the {@link Shape} for an item in the list.  The list is expanded if necessary.
    080         *
    081         * @param index  the index (zero-based).
    082         * @param shape  the {@link Shape}.
    083         */
    084        public void setShape(final int index, final Shape shape) {
    085            set(index, shape);
    086        }
    087
    088        /**
    089         * Returns an independent copy of the list.
    090         *
    091         * @return A clone.
    092         *
    093         * @throws CloneNotSupportedException if an item in the list does not support cloning.
    094         */
    095        public Object clone() throws CloneNotSupportedException {
    096            return super.clone();
    097        }
    098
    099        /**
    100         * Tests the list for equality with another object (typically also a list).
    101         *
    102         * @param o  the other object.
    103         *
    104         * @return A boolean.
    105         */
    106        public boolean equals(final Object o) {
    107
    108            if (o == null) {
    109                return false;
    110            }
    111
    112            if (o == this) {
    113                return true;
    114            }
    115
    116            if (o instanceof ShapeList) {
    117                return super.equals(o);
    118            }
    119
    120            return false;
    121
    122        }
    123
    124        /**
    125         * Returns a hash code value for the object.
    126         *
    127         * @return the hashcode
    128         */
    129        public int hashCode() {
    130            return super.hashCode();
    131        }
    132
    133        /**
    134         * Provides serialization support.
    135         *
    136         * @param stream  the output stream.
    137         *
    138         * @throws IOException  if there is an I/O error.
    139         */
    140        private void writeObject(final ObjectOutputStream stream) throws IOException {
    141
    142            stream.defaultWriteObject();
    143            final int count = size();
    144            stream.writeInt(count);
    145            for (int i = 0; i < count; i++) {
    146                final Shape shape = getShape(i);
    147                if (shape != null) {
    148                    stream.writeInt(i);
    149                    SerialUtilities.writeShape(shape, stream);
    150                }
    151                else {
    152                    stream.writeInt(-1);
    153                }
    154            }
    155
    156        }
    157
    158        /**
    159         * Provides serialization support.
    160         *
    161         * @param stream  the input stream.
    162         *
    163         * @throws IOException  if there is an I/O error.
    164         * @throws ClassNotFoundException  if there is a classpath problem.
    165         */
    166        private void readObject(final ObjectInputStream stream) throws IOException, ClassNotFoundException {
    167
    168            stream.defaultReadObject();
    169            final int count = stream.readInt();
    170            for (int i = 0; i < count; i++) {
    171                final int index = stream.readInt();
    172                if (index != -1) {
    173                    setShape(index, SerialUtilities.readShape(stream));
    174                }
    175            }
    176
    177        }
    178
    179    }
    180